<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDataUsingDataContract StructType
 * @subpackage Structs
 */
class GetDataUsingDataContract extends AbstractStructBase
{
    /**
     * The composite
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CompositeType
     */
    public $composite;
    /**
     * Constructor method for GetDataUsingDataContract
     * @uses GetDataUsingDataContract::setComposite()
     * @param \StructType\CompositeType $composite
     */
    public function __construct(\StructType\CompositeType $composite = null)
    {
        $this
            ->setComposite($composite);
    }
    /**
     * Get composite value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CompositeType|null
     */
    public function getComposite()
    {
        return isset($this->composite) ? $this->composite : null;
    }
    /**
     * Set composite value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CompositeType $composite
     * @return \StructType\GetDataUsingDataContract
     */
    public function setComposite(\StructType\CompositeType $composite = null)
    {
        if (is_null($composite) || (is_array($composite) && empty($composite))) {
            unset($this->composite);
        } else {
            $this->composite = $composite;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetDataUsingDataContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
